#include<iostream>
#include<cmath>
#include<vector>
#include<algorithm>
using namespace std;
int n, m, parents[100000], cost = 0;
long long heights[100000];
bool afsa = true;
int parentFind(int node){
    int ans = parents[node];
    while(ans != parents[ans]){
        ans = parents[ans];
    }
    return ans;
}
int mod(int a){
    if(a >= 0)
        return a;
    return -a;
}
void groupUnion(int a, int b){
    int parentA = parentFind(a), parentB = parentFind(b);
    if(parentA == parentB)
        return;
    //for(int i = 0; i < n; ++i){ cout << parents[i] << " ";}
    //cout << " uniting group " << parentA << " with " << parentB << "; ";
    vector<int> heightsA, heightsB;
    for(int i = 0; i < n; ++i){
        int z = parentFind(i);
        if(z == parentA)
            heightsA.push_back(heights[i]);
        if(z == parentB)
            heightsB.push_back(heights[i]);
    }

    int sa = heightsA.size(), sb = heightsB.size(), minCost = 1353789;
    for(int i = 0; i < sa; ++i){
        for(int j = 0; j < sb; ++j){
            //cout << "{" << heightsA[i] << ", " << heightsB[j] << "} ";
            int currCost;
            currCost = mod(heightsA[i] - heightsB[j]);
            if(currCost < minCost){
                minCost = currCost;
            }
        }
    }

    parents[b] = parentA;
   // cout << "cost: " << minCost << endl;
    cost += minCost;
}
void input(){
    cin >> n >> m;
    for(int i = 0; i < n; ++i){
        cin >> heights[i];
        if(heights[i] != i + 1)
            afsa = false;
    }
    for(int i = 0; i < n; ++i){
        parents[i] = i;
    }
    for(int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        parents[b - 1] = parentFind(a - 1);
    }
}
int main(){
    input();
    if(afsa){
        int groups[n], groupCount = 0;
        for(int i = 0; i < n; ++i){
            groups[i] = parentFind(i);
        }
        sort(groups, groups + n);
        for(int i = 1; i < n; ++i){
            if(groups[i] != groups[i - 1])
                groupCount++;
        }
        cout << n - groupCount - 1;
        return 0;
    }
    for(int i = 1; i < n; ++i){
        groupUnion(parentFind(0), i);
    }
    cout << cost;
    return 0;
}
/*
6 2
60 69 30 37 42 57
1 2
4 6

ans: 25?

*/
