#include <bits/stdc++.h>
using namespace std;

const int MAXN = 100007;
const int MAXM = 100007;

vector<int> G1[MAXN];
int c[MAXN];
int component[MAXN];
vector<int> comps[MAXN];
vector<pair<int, int>> G2[MAXN];
int n, m;
int k = 0;

void dfs_comps(int curr, int comp){
    comps[comp].push_back(c[curr]);
    component[curr] = comp;
    for(int i = 0; i < G1[curr].size(); i++){
        if(component[G1[curr][i]] == 0){
            dfs_comps(G1[curr][i], comp);
        }
    }
}

int dist(int a, int b){
    return abs(a-b);
}

int dist(const vector<int>& a, const vector<int>& b){
    int minD = INT_MAX;

    int ai = 0, bi = 0;
    int last = -1;
    bool lastFromB = false;
    while((ai != a.size()) || (bi != b.size())){
        int curr;
        bool currFromB;
        if(ai != a.size() && bi != b.size()){
            if(a[ai] < b[bi]){
                curr = a[ai];
                ai++;
                currFromB = false;
            }else{
                curr = b[bi];
                bi++;
                currFromB = true;
            }
        }else if(ai == a.size()){
            curr = b[bi];
            bi++;
            currFromB = true;
        }else if(bi == b.size()){
            curr = a[ai];
            ai++;
            currFromB = false;
        }else{
            cerr << "PANIKA!!!\n";
        }


//        cout << "\t" << curr << " " << (currFromB?"b\n":"a\n");
        if(currFromB != lastFromB && last != -1){
            int d = dist(last, curr);
//            cout << "\t\td = " << d << '\n';
            minD = min(d, minD);
        }

        last = curr;
        lastFromB = currFromB;
    }
    return minD;
}

int main(){
    /**
      *    ZAGUBI IGRATA
      */
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        cin >> c[i];
    }
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--; v--;
        G1[u].push_back(v);
        G1[v].push_back(u);
    }

    /// namirane na svurzani komponenti
    for(int i = 0; i < n; i++){
        if(component[i] == 0){
            dfs_comps(i, ++k);
        }
    }


    for(int i = 1; i <= k; i++){
        sort(comps[i].begin(), comps[i].end());
//        cout << "sorted: ";
//        for(int el : comps[i]){
//            cout << el << ' ';
//        }cout << '\n';
    }

    vector<int> ds;

    for(int i = 1; i <= k; i++){
        for(int j = i+1; j <= k; j++){
            int d = dist(comps[i], comps[j]);
//            cout << "dist between C#" << i << " and C#" << j << " is " << d << '\n';
            G2[i].push_back({j, d});
            G2[j].push_back({i, d});
            ds.push_back(d);
        }
    }

    sort(ds.begin(), ds.end());
    int sum = 0;
    for(int i = 0; i < k-1; i++){
        sum += ds[i];
    }

    cout << sum << '\n';
    return 0;
}
