#include <bits/stdc++.h>

using namespace std;

const long long inf = (1LL << 62);
const int maxn = 100005;

int n, m;

long long cost[maxn];

vector<int> g[maxn];
bool visited[maxn];

int curr = 0;
vector<long long> comps[maxn];

long long precalc[20][20];

void dfs(int node)
{
    visited[node] = true;
    comps[curr].push_back(cost[node]);

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

long long myabs(long long x)
{
    if (x < 0)
    {
        return -x;
    }

    return x;
}

long long find_min_diff(int i, int j, long long x)
{
    auto it = lower_bound(comps[j].begin(), comps[j].end(), x);

    long long diff = inf;
    long long num = 0;

    if (it != comps[j].end())
    {
        num = *it;

        diff = min(diff, myabs(num - x));
    }

    if (it != comps[j].begin())
    {
        --it;
        num = *it;
        diff = min(diff, myabs(num - x));
    }

    return diff;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            ++curr;
            dfs(i);
        }
    }

    for (int i = 1; i <= curr; ++i)
    {
        sort(comps[i].begin(), comps[i].end());
    }

    for (int i = 1; i <= curr; ++i)
    {
        for (int j = 1; j <= curr; ++j)
        {
            if (j <= i)
            {
                precalc[i][j] = inf;
                continue;
            }

            long long res = inf;

            for (auto c : comps[i])
            {
                res = min(res, find_min_diff(i, j, c));
            }

            precalc[i][j] = res;
        }
    }

    priority_queue<long long> pq;

    for (int i = 1; i <= curr; ++i)
    {
        for (int j = 1; j <= curr; ++j)
        {
            if (precalc[i][j] != inf)
            {
                pq.push(-precalc[i][j]);
            }
        }
    }

    long long ans = 0;

    for (int i = 1; i < curr; ++i)
    {
        ans += (-pq.top());
        pq.pop();
    }

    cout << ans << endl;

    return 0;
}
