#include <bits/stdc++.h>

using namespace std;

const long long inf = (1LL << 62);
const int maxn = 100005;

const int max_curr = 17;
const int max_mask = (1 << 17);

long long dp[max_curr][max_mask];
bool bl[max_curr][max_mask];

int n, m;

long long cost[maxn];

vector<int> g[maxn];
bool visited[maxn];

int curr = 0;
vector<long long> comps[maxn];

long long precalc[20][20];

void dfs(int node)
{
    visited[node] = true;
    comps[curr].push_back(cost[node]);

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

long long myabs(long long x)
{
    if (x < 0)
    {
        return -x;
    }

    return x;
}

long long find_min_diff(int i, int j, long long x)
{
    auto it = lower_bound(comps[j].begin(), comps[j].end(), x);

    long long diff = inf;
    long long num = 0;

    if (it != comps[j].end())
    {
        num = *it;

        diff = min(diff, myabs(num - x));
    }

    if (it != comps[j].begin())
    {
        --it;
        num = *it;
        diff = min(diff, myabs(num - x));
    }

    return diff;
}

int parent[maxn];
int depth[maxn];

int root(int node)
{
    if (node == parent[node])
    {
        return node;
    }

    return parent[node] = root(parent[node]);
}

void connect(int x, int y)
{
    x = root(x);
    y = root(y);

    if (depth[x] == depth[y])
    {
        parent[y] = x;
        depth[x]++;
    }
    else if (depth[x] > depth[y])
    {
        parent[y] = x;
    }
    else
    {
        parent[x] = y;
    }
}

bool is_connected(int x, int y)
{
    return root(x) == root(y);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            ++curr;
            dfs(i);
        }
    }

    for (int i = 1; i <= curr; ++i)
    {
        sort(comps[i].begin(), comps[i].end());
    }

    vector<tuple<int, int, long long>> edges;

    for (int i = 1; i <= curr; ++i)
    {
        for (int j = 1; j <= curr; ++j)
        {
            if (j <= i)
            {
                precalc[i][j] = precalc[j][i];
                continue;
            }

            long long res = inf;

            for (auto c : comps[i])
            {
                res = min(res, find_min_diff(i, j, c));
            }

            precalc[i][j] = res;

            edges.push_back(make_tuple(i, j, precalc[i][j]));
        }
    }

    for (int i = 1; i <= curr; ++i)
    {
        parent[i] = i;
        depth[i] = 1;
    }

    sort(edges.begin(), edges.end());

    long long ans = 0;

    for (auto [x, y, w] : edges)
    {
        if (is_connected(x, y) == false)
        {
            ans += w;
            connect(x, y);
        }
    }

    cout << ans << endl;

    return 0;
}
/*
4 0
4 5 1 1000000000
*/
