#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1;
int N, M;
int H[MAX_N];
set<int> edges[MAX_N], comp_edges[MAX_N];
int components[MAX_N];
bool visited[MAX_N];
vector<int> components_set;

void dfs(int u, int component)
{
    if(visited[u])
    {
        return;
    }

    components[u]=component;
    visited[u]=true;
    comp_edges[component].insert(u);

    for(auto& v:edges[u])
    {
        dfs(v, component);
    }
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M;

    bool is_goofy=true;

    for(int i=1; i<=N; i++)
    {
        cin >> H[i];

        if(H[i]!=i)
        {
            is_goofy=false;
        }
    }

    for(int i=0; i<M; i++)
    {
        int u, v;
        cin >> u >> v;
        edges[u].insert(v);
        edges[v].insert(u);
    }

    for(int i=1; i<=N; i++)
    {
        if(visited[i])
        {
            continue;
        }

        dfs(i, i);
        components_set.push_back(i);
    }

    if(is_goofy)
    {
        cout << components_set.size()-1;
    }
    else
    {
        vector<long long> dp(N);

        for(int i=1; i<=N; i++)
        {
            dp[i]=1e9;
        }

        dp[0]=0;

        for(int i=1; i<components_set.size(); i++)
        {
            for(int j=0; j<i; j++)
            {
                for(auto& haha:comp_edges[components_set[i]])
                {
                    for(auto& haha2:comp_edges[components_set[j]])
                    {
                        dp[i]=min(dp[i], dp[j]+abs(H[haha]-H[haha2]));
                    }
                }
            }
        }

        cout << dp[components_set.size()-1];
    }
    return 0;
}