# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
using namespace std;

const int MAX=1e5+1;
int n,m;
pair<long, long> c[MAX];
vector<int> a[MAX];

vector<pair<long long,long long>> nei[MAX];
void neighbours()
{
    for(int i=1; i<=n; i++)
    {
        cin>>c[i].first;
        c[i].second=i;
    }

    sort(c+1,c+n+1);

    for(int i=2; i<=n-1; i++)
    {
        nei[c[i].second].push_back({abs(c[i-1].first-c[i].first),c[i-1].second});
        nei[c[i].second].push_back({abs(c[i+1].first-c[i].first),c[i+1].second});
    }

    nei[c[1].second].push_back({abs(c[1].first-c[2].first),c[2].second});
    nei[c[n].second].push_back({abs(c[n].first-c[n-1].first),c[n-1].second});

    /*
    for(int i=1;i<=n;i++)
    {
        cout<<i<<":"<<endl;
        for(auto p: nei[i])
        {
            cout<<p.first<<" "<<p.second<<endl;
        }
    }
    */
}

int vis[MAX];
int comp=0;
vector<int> k[MAX];

void dfs(int curr)
{
    vis[curr]=comp;
    k[comp].push_back(curr);
    for(auto next: a[curr])
    {
        if(vis[next]==0) dfs(next);
    }
}

void comps()
{
    for(int i=1; i<=m; i++)
    {
        int x,y;
        cin>>x>>y;
        if(x!=y)
        {
            a[x].push_back(y);
            a[y].push_back(x);
        }
    }

    for(int i=1; i<=n; i++)
    {
        if(vis[i]==0)
        {
            comp++;
            dfs(i);
        }
    }

    /*
    cout<<comp<<endl;
    for(int i=1;i<=comp;i++)
    {
        cout<<i<<":";
        for(auto u: k[i]) cout<<u<<" ";
        cout<<endl;
    }
    */
}

void dijkstra()
{
    long long ans=0,br=k[1].size();
    priority_queue<pair<long long, long long>> q;
    for(int u: k[1])
    {
        for(auto p: nei[u])
        {
            q.push({-p.first,p.second});
        }
    }

    while(br<n and q.size()>0)
    {
        int dist=-q.top().first,curr=q.top().second;
        q.pop();

        if(vis[curr]==1) continue;

        ans=ans+dist;
        br=br+k[vis[curr]].size();
        for(int u: k[vis[curr]])
        {
            vis[u]=1;
            for(auto p: nei[u])
            {
                q.push({-p.first,p.second});
            }
        }
    }

    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;

    neighbours();
    comps();
    dijkstra();
    return 0;
}

