#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
int n, m, leader[maxn], c[maxn];
vector<int> g[maxn], comp[maxn];
set<int> s[maxn];

int find_leader(int x){
    if(leader[x] == x)
        return x;
    return leader[x] = find_leader(leader[x]);
}

long long cost;
struct edge{
    int a, b, c;
};
vector<edge> v;

void unite(edge e){
    int lx = find_leader(e.a);
    int ly = find_leader(e.b);
    if(lx != ly){
        leader[lx] = ly;
        cost += e.c;
    }
}

bool cmp(edge e1, edge e2){
    return e1.c < e2.c;
}

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
        leader[i] = i;
    }
    for(int i = 1;i <= m;i++){
        int a, b;
        cin >> a >> b;
        v.push_back({a, b, 0});
        g[a].push_back(b);
        g[b].push_back(a);
    }
}
int used[maxn];
void dfs(int ver, int cnt){
    comp[cnt].push_back(ver);
    s[cnt].insert(c[ver]);
    used[ver] = 1;
    for(int nb : g[ver]){
        if(!used[nb])
            dfs(nb, cnt);
    }
}

void solve(){
    int cnt = 0;
    for(int i = 1;i <= n;i++){
        if(!used[i]){
            ++cnt;
            dfs(i, cnt);
        }
    }
    for(int i = 1;i <= cnt;i++){
        for(int j = i + 1;j <= cnt;j++){
            int ans = 1e9;
            for(int x : comp[i]){
                s[j].insert(c[x]);
                auto it = s[j].find(c[x]);
                if(it != s[j].begin()){
                    it--;
                    ans = min(ans, abs((*it) - c[x]));
                    it++;
                }
                it++;
                if(it != s[j].end()){
                    ans = min(ans, abs((*it) - c[x]));
                }
                it--;
                s[j].erase(it);
            }
            v.push_back({comp[i][0], comp[j][0], ans});
        }
    }
    sort(v.begin(), v.end(), cmp);
    for(edge e : v)
        unite(e);
    cout << cost << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
