#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
int n, m, leader[maxn], c[maxn], f[maxn];
vector<int> g[maxn], comp[maxn];

int find_leader(int x){
    if(leader[x] == x)
        return x;
    return leader[x] = find_leader(leader[x]);
}

long long cost;
struct edge{
    int a, b, c;
};
vector<edge> v;

void unite(edge e){
    int lx = find_leader(e.a);
    int ly = find_leader(e.b);
    if(lx != ly){
        leader[lx] = ly;
        cost += e.c;
    }
}

bool cmp(edge e1, edge e2){
    return e1.c < e2.c;
}

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
        leader[i] = i;
    }
    for(int i = 1;i <= m;i++){
        int a, b;
        cin >> a >> b;
        v.push_back({a, b, 0});
        g[a].push_back(b);
        g[b].push_back(a);
    }
}
int used[maxn];
void dfs(int ver, int cnt){
    comp[cnt].push_back(c[ver]);
    used[ver] = 1;
    for(int nb : g[ver]){
        if(!used[nb])
            dfs(nb, cnt);
    }
}

void solve(){
    int cnt = 0;
    for(int i = 1;i <= n;i++){
        if(!used[i]){
            ++cnt;
            f[cnt] = i;
            dfs(i, cnt);
        }
    }
    for(int i = 1;i <= cnt;i++)
        sort(comp[i].begin(), comp[i].end());
    for(int i = 1;i <= cnt;i++){
        
        for(int j = i + 1;j <= cnt;j++){
            int ans = 1e9;int k = 0;
            for(int p = 0;p < comp[j].size();p++){
                while(k < comp[i].size() && comp[i][k] <= comp[j][p])
                    k++;
                if(k != 0) k--;
                ans = min(ans, abs(comp[i][k] - comp[j][p]));
                if(k != comp[i].size() - 1){
                    ans = min(ans, abs(comp[i][k + 1] - comp[j][p]));
                }
            }
            v.push_back({f[i], f[j], ans});
        }

    }
    sort(v.begin(), v.end(), cmp);
    for(edge e : v)
        unite(e);
    cout << cost << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
